'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _request = require('request');

var _request2 = _interopRequireDefault(_request);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Base = function () {
  function Base(options) {
    _classCallCheck(this, Base);

    if (options) {
      if (options.verbose) {
        _request2.default.debug = true;
      }
      if (options.timeout) {
        this.timeout = options.timeout;
      }
    }
  }

  _createClass(Base, [{
    key: 'getRequestSettings',
    value: function getRequestSettings() {
      return {};
    }
  }, {
    key: 'preprocessBody',
    value: function preprocessBody(body) {
      return body;
    }
  }, {
    key: 'validate',
    value: function validate() {
      return true;
    }
  }, {
    key: 'parseLocation',
    value: function parseLocation() {
      return {};
    }
  }, {
    key: 'parseError',
    value: function parseError(body) {
      return body;
    }
  }, {
    key: 'locate',
    value: function locate(cell, callback) {
      var _this = this;

      //  Send request
      var options = this.getRequestSettings(cell);
      options.timeout = this.timeout;

      (0, _request2.default)(options, function (error, response, body) {
        if (error) {
          if (error.code === 'ETIMEDOUT' || error.code === 'ESOCKETTIMEDOUT') {
            if (error.connect === true) {
              callback('Request connection timeout.', null);
            } else {
              callback('Request timeout.', null);
            }
          } else {
            //  Callback with error
            if (_lodash2.default.isFunction(callback)) {
              callback('Request Error: ' + JSON.stringify(error), null);
            }
          }
        } else {
          var b = _this.preprocessBody(body);
          if (response.statusCode === 200) {
            if (!_this.validate(b)) {
              //  Callback with error message
              if (_lodash2.default.isFunction(callback)) {
                callback('Response Error: ' + JSON.stringify(_this.parseError(b)), null);
              }
            } else {
              //  Callback with location info
              if (_lodash2.default.isFunction(callback)) {
                callback(null, _this.parseLocation(b));
              }
            }
          } else {
            //  Callback with HTTP Status Error Code
            if (_lodash2.default.isFunction(callback)) {
              var status = response.statusCode + ': ' + response.statusMessage;
              callback('Response Error: ' + status + ' (' + JSON.stringify(_this.parseError(b)) + ')', null);
            }
          }
        }
      });
    }
  }]);

  return Base;
}();

exports.default = Base;