'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.map = exports.locator = exports.LocatorManager = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _googleGeolocation = require('./engines/google-geolocation');

var _googleGeolocation2 = _interopRequireDefault(_googleGeolocation);

var _mozillaGeolocation = require('./engines/mozilla-geolocation');

var _mozillaGeolocation2 = _interopRequireDefault(_mozillaGeolocation);

var _opencellid = require('./engines/opencellid');

var _opencellid2 = _interopRequireDefault(_opencellid);

var _yandex = require('./engines/yandex');

var _yandex2 = _interopRequireDefault(_yandex);

var _cellocation = require('./engines/cellocation');

var _cellocation2 = _interopRequireDefault(_cellocation);

var _gpsspg = require('./engines/gpsspg');

var _gpsspg2 = _interopRequireDefault(_gpsspg);

var _haoservice = require('./engines/haoservice');

var _haoservice2 = _interopRequireDefault(_haoservice);

var _mylnikov = require('./engines/mylnikov');

var _mylnikov2 = _interopRequireDefault(_mylnikov);

var _unwiredlabs = require('./engines/unwiredlabs');

var _unwiredlabs2 = _interopRequireDefault(_unwiredlabs);

var _mapservice = require('./mapservice');

var _mapservice2 = _interopRequireDefault(_mapservice);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var LocatorManager = exports.LocatorManager = function () {
  function LocatorManager() {
    _classCallCheck(this, LocatorManager);

    this.engines = [];
    //  register existing services
    this.register('google', _googleGeolocation2.default);
    this.register('mozilla', _mozillaGeolocation2.default);
    this.register('opencellid', _opencellid2.default);
    this.register('yandex', _yandex2.default);
    this.register('cellocation', _cellocation2.default);
    this.register('gpsspg', _gpsspg2.default);
    this.register('haoservice', _haoservice2.default);
    this.register('mylnikov', _mylnikov2.default);
    this.register('unwiredlabs', _unwiredlabs2.default);
  }

  _createClass(LocatorManager, [{
    key: 'register',
    value: function register(name, engine) {
      this.engines[name] = engine;
    }
  }, {
    key: 'unregister',
    value: function unregister(name) {
      delete this.engines[name];
    }
  }, {
    key: 'createEngine',
    value: function createEngine(name, options) {
      if (this.engines[name]) {
        return new this.engines[name](options);
      }
      return null;
    }
  }]);

  return LocatorManager;
}();

var locator = exports.locator = new LocatorManager();
exports.default = locator;
var map = exports.map = new _mapservice2.default();