'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var MapServices = function () {
  function MapServices() {
    _classCallCheck(this, MapServices);

    this.services = [];
    this.register('google', 'https://www.google.com/maps/@${lat},${long},${range}m/data=!3m1!1e3');
    this.register('bing', 'https://www.bing.com/maps/?v=2&cp=${lat}~${long}&style=h&lvl=16');
    this.register('google.cn', 'http://www.google.cn/maps/@${lat},${long},${range}m/data=!3m1!1e3');
    this.register('bing.cn', 'https://www.bing.com/ditu/?v=2&cp=${lat}~${long}&style=h&lvl=16');
    this.register('openstreetmap', 'http://www.openstreetmap.org/#map=16/${lat}/${long}');
    this.register('baidu', 'http://api.map.baidu.com/marker?location=${lat},${long}&title=_&content=${addr}&output=html&autoOpen=true');
  }

  _createClass(MapServices, [{
    key: 'register',
    value: function register(name, template) {
      this.services[name] = template;
    }
  }, {
    key: 'unregister',
    value: function unregister(name) {
      delete this.services[name];
    }
  }, {
    key: 'format',
    value: function format(name, location) {
      return this.services[name].replace('${lat}', location.latitude).replace('${long}', location.longitude).replace('${range}', location.accuracy).replace('${addr}', location.address);
    }
  }]);

  return MapServices;
}();

exports.default = MapServices;